; 18F2320-al vezrelt Logic Gate FET meghajtssal felptett Krt.
	LIST P=18F2320, F=INHX32	
	#include <P18F2320.INC>	
	ERRORLEVEL -230 


;	__CONFIG	_CONFIG1L   Nem hasznlt regiszter
	;__CONFIG	_CONFIG1H, 	b'10000010'		; HS Osc
	
	__CONFIG	_CONFIG1H, 	b'00001000'		; INTERNAL RC OSC
	__CONFIG	_CONFIG2L, 	b'00000100'		; Brown-out Reset dis enabled 4,2V, PWRT enabled
	__CONFIG	_CONFIG2H, 	b'00001101'		; WDT ON 64*4ms=0,256 => ~4Hz
;	__CONFIG	_CONFIG3L,  Nem hasznlt regiszter
	__CONFIG	_CONFIG3H, 	b'00000001'		; RE3 input pin enabled; MCLR disabled, PortB <4:0> digit I/O ;CCP2 input/output is multiplexed with RC1
	__CONFIG	_CONFIG4L, 	b'10000001'		; Background Debugger disabled, STACK FULL - RESET
;	__CONFIG	_CONFIG4H,  Nem hasznlt regiszter	
	__CONFIG	_CONFIG5L, 	b'00001111'		; CODE PROTECT OFF 
	__CONFIG	_CONFIG5H, 	b'11000000'		; EEPROM, BOOTBLOCK PROTECT OFF
	__CONFIG	_CONFIG6L,  b'00001111'		; WRITE PROTECT OFF 
	__CONFIG	_CONFIG6H, 	b'11100000'		; EEPROM WRITE, BOOT WRITE, CONF REG WRITE PROTECT OFF
	__CONFIG	_CONFIG7L,  b'00001111'		; TABLE READ PROTECTION OFF
	__CONFIG	_CONFIG7H, 	b'01000000'		; BOOT READ PROTECT OFF

;***ID Location Define

	__IDLOCS _IDLOC0, 'K'
	__IDLOCS _IDLOC1, ''
	__IDLOCS _IDLOC2, 'R'
	__IDLOCS _IDLOC3, 'T'
	__IDLOCS _IDLOC4, 'W'
	__IDLOCS _IDLOC5, 'A'
	__IDLOCS _IDLOC6, 'T'
	__IDLOCS _IDLOC7, 'T'	 


;............................. ALAP DEKLARLSOK  ............................

	#DEFINE		TMR1_INT_E_T	PIE1,0
	#DEFINE		TMR1_INT_FLAG	PIR1,0
	
	#DEFINE		TMR0_INT_E_T	INTCON,5		; TIMER0 MEGSZAKITAS ENGEDELYEZES/TILTAS BIT
	#DEFINE		TMR0_INT_FLAG	INTCON,2		; TIMER0 MEGSZAKITAS JELZO BIT.
	
	#DEFINE		ALL_INT_E_T		INTCON,7		; GLOBALIS MEGSZAKITASOK ENGEDELYEZESE_TILTAS
	#DEFINE		ALL_PINT_E_T	INTCON,6		; PERIFERIA MEGSZAKITASOK ENGEDELYEZESE_TILTAS

	#DEFINE		FREKI_KI_INV		PORTC,4			; Invertlt freki kimenet
	#DEFINE		FREKI_KI_NINV		PORTC,5			; Nem Invertlt freki kimenet
	
	#DEFINE		SPI_IO_E		SSPCON1,SSPEN	; SPI PIC ENGEDLYEZS
	
	
	#DEFINE		EFFEKT_1_GOMB	PORTB,5
	#DEFINE		EFFEKT_2_GOMB	PORTB,4
	#DEFINE		EFFEKT_3_GOMB	PORTB,3
	#DEFINE		EFFEKT_4_GOMB	PORTB,2
	#DEFINE		EFFEKT_5_GOMB	PORTB,1
	#DEFINE		EFFEKT_6_GOMB	PORTB,0	
	
	#DEFINE		ALARM_LB		PORTA,0			; RIASZTRL JN EGY 5V-os JEL

;............................ MAKRK ..................................................

Makrk	MACRO
        
        ENDM

;..................................llandk .................................................
              

;................................ VALTOZ DEKLARALAS ........................................
					
	CBLOCK		0X0020
		AKKU_TEMP
		STATUS_TEMP
		BSR_TEMP
		
		FREKI_L		; EZ HATROZZA MEG A KIMENETI FREKVENCIT.
		FREKI_H		; 
		
		LPS_TEM
		
		FREKI_KEZD_H
		FREKI_KEZD_L
		FREKI_BEFEJEZ_H
		FREKI_BEFEJEZ_L
		VLTOZS_SEBESSGE	; EFFEKT SZUBRUTINOK BEMEN PARAMTEREI.
		
		FREKI_KITARTS_L
		FREKI_KITARTS_H	; KITARTS IDTARTAMT SZMOLJA
		
		CIKLUS
		CIKLUS_B
		
		SZNET_L
		SZNET_H			; SZNET KRS SZMLL (10KHz TEMMEL)

		GOMB_PRELL			; PRELL MENTESTS
		
		KRT_PER_L
		KRT_PER_H			; KRT HORN PERIDUS ID SZNETNEK
		
		FLAG_1
	ENDC

;	------------------------- FLAG DEKRALLSOK -----------------------------

	#DEFINE		SZNET_KRS	FLAG_1,0
	#DEFINE 	LPS_TEM_JEL	FLAG_1,1
	#DEFINE		FR_KITARTS_KRS	FLAG_1,2
	#DEFINE		BREAK			FLAG_1,3
	#DEFINE		GOMB_ENG		FLAG_1,4
	#DEFINE		GOMB_LENYOMVA	FLAG_1,5
	#DEFINE		KRT_PERIOD_KRS	FLAG_1,6
	#DEFINE		RIASZTS_JEL	FLAG_1,7	
	
;*******************************************************************************
;.......................RESET PONT.............................................	
	ORG	0X0000
	BRA 	INI
	ORG	0X0008
	GOTO 	MEGSZAK
	ORG	0X0018
	RETFIE

; -------------------- INICIALIZALASOK --------------------------------------------
INI

	BCF		INTCON2,7			; PORTB FELHZ ELLENALLAS ON
	CLRF	INTCON
	CLRF	PIE1
	MOVLW	B'00001111'			; PORTA DIGIT I/O
	MOVWF	ADCON1	

	MOVLW	B'11111011'
	MOVWF	OSCCON				; Bels OSC 8MHz, freki hangols, 
	MOVLW	B'11000111'			; CENTER: XX000000	 MIN: XX111111...XX100000  MAX: XX000001...XX011111  
	MOVWF	OSCTUNE				; FREKI HANGOLS

;------------------------- PORTOK BELLTSA --------------------------------------------
	MOVLW	B'11111111'			; MINDEN BEMENET
	MOVWF	TRISA				; PORTA BEALLITASA
	MOVLW	B'11111111'			; MINDEN BEMENET
	MOVWF	TRISB				; PORTB BEALLITASA
 	MOVLW	B'11000111'			; RC4, RC5 FREKI KI, RC3 LED, TBBI BEMENET
	MOVWF	TRISC				; PORTC BEALLITASA!!

	BCF		FREKI_KI_INV
	BCF		FREKI_KI_NINV 			; ALAPHELYZET


; ------------------------- MEGSZAKITASOK BEALLITASAI -----------------------------------------------

	MOVLW	B'00000100'			; TIMER0 MEGSZAKITAS MAGAS SZINT LEKEZELES
	MOVWF	INTCON2
	CLRF	INTCON3				; KULSO MEGSZAKITAS FORRASOK LETILTVA, FLAGEK TOROLVE
	CLRF	IPR1
	CLRF	IPR2
	CLRF	PIE1
	CLRF	PIE2
	CLRF	PIR1
	CLRF	PIR2				; MEGSZAKITASOKAT KEZELO REGISZTEREK ALAPHELYZETBE ALLITVA
	BSF		IPR1,0				; TIMER1 HIGHT MEGSZAKTS LEKEZELS

; ------------------------- TIMEREK BELLTSA -------------------------------------
	MOVLW	B'11000010'			; TIMER0 BEALLITASA. TIMER0 ON
								; 8 bites md. ELOSZT 1:8 
								; 8MHz nl a megszakts: KB 1000Hz
	MOVWF	T0CON
	MOVLW	B'10000001'			; T1 ON, T1 START, ELOSZT 1:1, 16bit MD, KLS OSZCI OFF
	MOVWF	T1CON
	BSF		TMR1_INT_E_T		; T1 INT EN
	BSF		TMR0_INT_E_T		; T0 INT EN

;-------------------- SPI Belltsa -------------------------------------------------------------
 	
	BCF		SSPCON1,SSPEN				; SSP OFF
		
;--------------- VLTOZK CONSTANSOK RTKADSOK-----------------------------------------
	#DEFINE		KEZD_FREKI(X) 	(.65536-.2000000/X)
	#DEFINE		BEFEJEZ_FREKI(X) 	(.65536-.2000000/X)
	#DEFINE		SEBESSG(X)			(X)
	CONSTANT	y =	2			; SZORZ A FREKIHEZ!! 
	
	MOVLW		.30				; msec-BEN
	MOVWF		GOMB_PRELL		; PRELLMENTEST RTK FELTLTSE

	CLRF	TMR1H
	CLRF	TMR1L
	BCF		BREAK
	BSF		GOMB_ENG	
	BCF		RIASZTS_JEL
		
;************************ PROGRAM MAG ******************************

	BSF		ALL_INT_E_T
	BSF		ALL_PINT_E_T
	bsf		WDTCON,SWDTEN	; watch dog bekapcsolva

; .... F CIKLUS ....

DO
	BTFSS	ALARM_LB			; ALARM JELZS JTT A RIASZTTL?
	BRA		GOMB_ENG_ELL		; HA NEM, UGRIK
	BSF		RIASZTS_JEL		; JELZS BEKAPCSOLVA	
GOMB_ENG_ELL
	BTFSS	GOMB_ENG			; HA A GOMB KEZELS ENGEDLYEZVE VAN, UGRIK			
	BRA		DO
DO_EFF
	BTFSC	EFFEKT_1_GOMB	
	BRA		EFF_SKIP_1
NINCS_ELENGEDVE
	BTFSS	EFFEKT_1_GOMB
	BRA		NINCS_ELENGEDVE		; BERAGASZTJUK IDE, MG ELENGEDJK A GOMBBOT	
	BTG		RIASZTS_JEL		; TVLTJUK A JELZT
	MOVLW	.255
	MOVWF	VLTOZS_SEBESSGE
	CALL	TEM_DELAY
	CALL	TEM_DELAY
	CALL	TEM_DELAY
	CALL	TEM_DELAY			
EFF_SKIP_1	
	BTFSS	RIASZTS_JEL		; VAN RIASZTS JEL?		
	BRA		EFF_SKIP_2	
	CALL	EFFEKT_1
	BRA  DO
EFF_SKIP_2	
	BTFSC	EFFEKT_2_GOMB
	BRA		EFF_SKIP_3
	BSF		GOMB_LENYOMVA		; JELZS BELLTVA
	CALL	EFFEKT_2
	BRA  EFF_SKIP_2	
EFF_SKIP_3
	BTFSC	EFFEKT_3_GOMB
	BRA		EFF_SKIP_4
	BSF		GOMB_LENYOMVA		; JELZS BELLTVA
	CALL	EFFEKT_3
	BRA  EFF_SKIP_3
EFF_SKIP_4
	BTFSC	EFFEKT_4_GOMB
	BRA		EFF_SKIP_5
	BSF		GOMB_LENYOMVA		; JELZS BELLTVA
	CALL	EFFEKT_4
	BRA  EFF_SKIP_4	
EFF_SKIP_5
	BTFSC	EFFEKT_5_GOMB
	BRA		EFF_SKIP_6
	BSF		GOMB_LENYOMVA		; JELZS BELLTVA
	CALL	EFFEKT_5
	BRA  EFF_SKIP_5	
EFF_SKIP_6
	BTFSC	EFFEKT_6_GOMB
	BRA		EFF_SKIP
	BSF		GOMB_LENYOMVA		; JELZS BELLTVA
	CALL	EFFEKT_6
	BRA  EFF_SKIP_6
EFF_SKIP
	BTFSS	GOMB_LENYOMVA
	BRA	 DO
	BCF		GOMB_LENYOMVA
	BCF		GOMB_ENG
	BRA  DO	

;*******************************************************************
;*******************************************************************











;...................... ELJRSOK ...... HANG EFFEKTEK ............................
	ORG 0X100
;.................
EFFEKT_1		; RIASZT HANGEFFEKT
	MOVLW	.8
	MOVWF	CIKLUS	; EFFEKT_5 IDTARTAMT LLTJA BE
EFF_5_VISZ
	CALL	EFFEKT_5
	DECFSZ	CIKLUS,F
	BRA		EFF_5_VISZ
	;SZNET
	MOVLW	LOW(.200)			; SZNET msec
	MOVWF	SZNET_L
	MOVLW	HIGH(.200)
	MOVWF	SZNET_H
	CALL	SZNET								; SZNET RUTIN MEGHVSA

	MOVLW	.3
	MOVWF	CIKLUS_B		; KRT MEGSZLALS SZMA
KRT_ALARM
	MOVLW	.11
	MOVWF	CIKLUS			; KRT HANGJNAK IDTARTAMA(VISZONYSZM)
EFF_4_VISZ
	CALL	EFFEKT_4
	DECFSZ	CIKLUS,F
	BRA		EFF_4_VISZ
	
	;SZNET
	MOVLW	LOW(.250)			; SZNET msec
	MOVWF	SZNET_L
	MOVLW	HIGH(.250)
	MOVWF	SZNET_H
	CALL	SZNET								; SZNET RUTIN MEGHVSA	

	DECFSZ	CIKLUS_B,F	
	BRA		KRT_ALARM

	MOVLW	.30
	MOVWF	CIKLUS			; MLYKRT HANG IDTARTAMA(VISZONYSZM)
M_KRT_V
	CALL	EFFEKT_3
	DECFSZ	CIKLUS,F
	BRA		M_KRT_V

	;SZNET
	MOVLW	LOW(.300)			; SZNET msec
	MOVWF	SZNET_L
	MOVLW	HIGH(.300)
	MOVWF	SZNET_H
	CALL	SZNET								; SZNET RUTIN MEGHVSA

	RETURN
	
; .............. FTTY ...	
	ORG	0X300
EFFEKT_2
	MOVLW	HIGH(KEZD_FREKI((.2500*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.2500*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.700*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.700*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.100)
	MOVWF	VLTOZS_SEBESSGE
	CALL	LEFUTS_KEZDET_VG_SEBESSG_SUB
	
	MOVLW	HIGH(KEZD_FREKI((.700*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.700*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.900*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.900*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.60)
	MOVWF	VLTOZS_SEBESSGE
	CALL	FELFUTS_KEZDET_VG_SEBESSG_SUB
	
	MOVLW	HIGH(KEZD_FREKI((.900*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.900*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.1500*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.1500*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.50)
	MOVWF	VLTOZS_SEBESSGE
	CALL	FELFUTS_KEZDET_VG_SEBESSG_SUB
	
	MOVLW	HIGH(KEZD_FREKI((.1500*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.1500*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.4500*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.4500*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.40)
	MOVWF	VLTOZS_SEBESSGE
	CALL	FELFUTS_KEZDET_VG_SEBESSG_SUB
	
	
	MOVLW	LOW(.2000)
	MOVWF	SZNET_L
	MOVLW	HIGH(.2000)
	MOVWF	SZNET_H
	CALL	SZNET
	
	RETURN

; ....... "MLY Horn" ..........	
EFFEKT_3
	ORG 0X500
	; FELFUTS
	MOVLW	HIGH(KEZD_FREKI((.230*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.230*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.250*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.250*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.10)
	MOVWF	VLTOZS_SEBESSGE
	CALL	FELFUTS_KEZDET_VG_SEBESSG_SUB

	; 
	#DEFINE	PERIOD2  	.1000	
	MOVLW	LOW(PERIOD2)
	MOVWF	KRT_PER_L
	MOVLW	HIGH(PERIOD2)
	MOVWF	KRT_PER_H	
	CALL	KRT_PERIDUS
	
	RETURN

; .........  STANDARD KRT  ........	
	ORG 0X700
EFFEKT_4
	; FELFUTS 
	MOVLW	HIGH(KEZD_FREKI((.600*y)))		; prba rtkek:
	MOVWF	FREKI_KEZD_H					; 630-650(30), 600-620(30), 600-630(19)!
	MOVLW	LOW(KEZD_FREKI((.600*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.630*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.630*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.19)
	MOVWF	VLTOZS_SEBESSGE
	CALL	FELFUTS_KEZDET_VG_SEBESSG_SUB

	; KB. 80Hz PERIDUS SZNET
	#DEFINE	PERIOD  	.2550	
	MOVLW	LOW(PERIOD)
	MOVWF	KRT_PER_L
	MOVLW	HIGH(PERIOD)
	MOVWF	KRT_PER_H
	CALL	KRT_PERIDUS


	; FELFUTS 
	MOVLW	HIGH(KEZD_FREKI((.600*y)))		; prba rtkek:
	MOVWF	FREKI_KEZD_H					; 630-650(30), 600-620(30), 600-630(19)!
	MOVLW	LOW(KEZD_FREKI((.600*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.630*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.630*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.19)
	MOVWF	VLTOZS_SEBESSGE
	CALL	FELFUTS_KEZDET_VG_SEBESSG_SUB

	; KB. 80Hz PERIDUS SZNET
	MOVLW	LOW(PERIOD)
	MOVWF	KRT_PER_L
	MOVLW	HIGH(PERIOD)
	MOVWF	KRT_PER_H
	CALL	KRT_PERIDUS

	RETURN
; KRT_RUTIN...
KRT_PERIDUS
	BCF		SZNET_KRS	
	BCF		FR_KITARTS_KRS
	BCF		FREKI_KI_INV
	BCF		FREKI_KI_NINV
	BSF		KRT_PERIOD_KRS
	BCF		ALL_INT_E_T
KRT_DO_L	
	DECF	KRT_PER_L,F
	MOVLW	0
	SUBWFB	KRT_PER_H,F	; HA L ALULCSORDULT, AKKOR H-1
	BNC		KRT_KSZ		; HA EZ IS ALULCSORDULT KSZ 
	BRA		KRT_DO_L	
KRT_KSZ
	BCF		KRT_PERIOD_KRS
	BSF		ALL_INT_E_T
	RETURN	


	; VERIFY MD TMOGATSA
	ORG	0X900

; ........... hyperyelp ......	
EFFEKT_5
	MOVLW	HIGH(KEZD_FREKI((.700*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.700*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.2000*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.2000*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.20)
	MOVWF	VLTOZS_SEBESSGE
	CALL	FELFUTS_KEZDET_VG_SEBESSG_SUB
	
	MOVLW	HIGH(KEZD_FREKI((.1000*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.1000*y)))
	MOVWF	FREKI_KEZD_L	
	MOVLW	HIGH(BEFEJEZ_FREKI((.700*y)))
	MOVWF	FREKI_BEFEJEZ_H
	MOVLW	LOW(BEFEJEZ_FREKI((.700*y)))
	MOVWF	FREKI_BEFEJEZ_L	
	MOVLW	SEBESSG(.20)
	MOVWF	VLTOZS_SEBESSGE
	CALL	LEFUTS_KEZDET_VG_SEBESSG_SUB
	
	RETURN


	org 0x1100
; ......... "DALLAM" KRT ........	
EFFEKT_6
	#DEFINE	E6_ID_1	.100	

	;FREKI_KITARTSA
	MOVLW	HIGH(E6_ID_1)		; (msec-ben!!)
	MOVWF	FREKI_KITARTS_H
	MOVLW	LOW(E6_ID_1)
	MOVWF	FREKI_KITARTS_L
	MOVLW	HIGH(KEZD_FREKI((.200*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.200*y)))
	MOVWF	FREKI_KEZD_L	
	CALL	FREKI_KITART_SUB
	
	;FREKI_KITARTSA
	MOVLW	HIGH(E6_ID_1)		; (msec-ben!!)
	MOVWF	FREKI_KITARTS_H
	MOVLW	LOW(E6_ID_1)
	MOVWF	FREKI_KITARTS_L
	MOVLW	HIGH(KEZD_FREKI((.400*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.400*y)))
	MOVWF	FREKI_KEZD_L	
	CALL	FREKI_KITART_SUB
	
	;FREKI_KITARTSA
	MOVLW	HIGH(E6_ID_1)		; (msec-ben!!)
	MOVWF	FREKI_KITARTS_H
	MOVLW	LOW(E6_ID_1)
	MOVWF	FREKI_KITARTS_L
	MOVLW	HIGH(KEZD_FREKI((.600*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.600*y)))
	MOVWF	FREKI_KEZD_L	
	CALL	FREKI_KITART_SUB

	;FREKI_KITARTSA
	MOVLW	HIGH(E6_ID_1)		; (msec-ben!!)
	MOVWF	FREKI_KITARTS_H
	MOVLW	LOW(E6_ID_1)
	MOVWF	FREKI_KITARTS_L
	MOVLW	HIGH(KEZD_FREKI((.800*y)))
	MOVWF	FREKI_KEZD_H
	MOVLW	LOW(KEZD_FREKI((.800*y)))
	MOVWF	FREKI_KEZD_L	
	CALL	FREKI_KITART_SUB
	
	;SZNET
	MOVLW	LOW(.1000)			; SZNET msec
	MOVWF	SZNET_L
	MOVLW	HIGH(.1000)
	MOVWF	SZNET_H
	CALL	SZNET								; SZNET RUTIN MEGHVSA

	RETURN	


	org 0x1300

; .................... FREKI FELFUTS .............................................
FELFUTS_KEZDET_VG_SEBESSG_SUB
	MOVFF	FREKI_KEZD_H,FREKI_H
	MOVFF	FREKI_KEZD_L,FREKI_L		; KEZD FREKI BETLTSE
	BCF		BREAK
	
KV_FREKI_LP
	CALL	TEM_DELAY			; VRJA A KVETKEZ LPST

	BTFSC	BREAK				; MEGSZAKTSJEL FIGYELSE
	RETURN						; HA VAN JEL, KILP

	INCF	FREKI_L,F			; FREKI VLTOZTATS
	MOVLW	0		
	ADDWFC	FREKI_H,F			; +1, HA VOLT TLCSORDULS L-ben

	MOVF	FREKI_BEFEJEZ_L,W	; 		
	CPFSEQ	FREKI_L				; Compare f with W, skip if f = W
	BRA		KV_FREKI_LP		; JABB KR
	MOVF	FREKI_BEFEJEZ_H,W
	CPFSEQ	FREKI_H				; FREKI_BEFEJEZ_X = FREKI_X, AKKOR KILP			
	BRA		KV_FREKI_LP		; JABB KR
	RETURN

; .................... FREKI LEFUTS .............................................
LEFUTS_KEZDET_VG_SEBESSG_SUB
	MOVFF	FREKI_KEZD_H,FREKI_H
	MOVFF	FREKI_KEZD_L,FREKI_L		; KEZD FREKI BETLTSE
	BCF		BREAK	
	
KV_FREKI_LP_LE
	CALL	TEM_DELAY			; VRJA A KVETKEZ LPST

	BTFSC	BREAK				; MEGSZAKTSJEL FIGYELSE
	RETURN						; HA VAN JEL, KILP
	DECF	FREKI_L,F			; FREKI VLTOZTATS -1
	BTFSS	STATUS,C			; VOLT ALULCSORDULS? HA NEM AKKOR UGRIK		
	DECF	FREKI_H,F			; -1, HA VOLT TLCSORDULS L-ben
	MOVF	FREKI_BEFEJEZ_L,W	; 		
	CPFSEQ	FREKI_L				; Compare f with W, skip if f = W
	BRA		KV_FREKI_LP_LE	; JABB KR
	MOVF	FREKI_BEFEJEZ_H,W
	CPFSEQ	FREKI_H				; FREKI_BEFEJEZ_X = FREKI_X, AKKOR KILP			
	BRA		KV_FREKI_LP_LE	; JABB KR
	RETURN

; .............. SZNET (A hvs eltt be kell lltani a vrakozs idtartamt) .........
SZNET
	BSF		SZNET_KRS		; KRS JELZ BEKAPCSOLVA	
	BCF		BREAK
SZNET_VR
	BTFSS	SZNET_KRS		; Vrakozik a SZNET_KRS jel trlsre(MEGSZAKTSBAN TRDIK)	
	BRA		SZN_KSZ
	BTFSC	BREAK				; VOLT PROGRAM MEGSZAKTS?
	BRA		SZN_KSZ			; HA IGEN
	BRA		SZNET_VR			; HA NEM AKKOR VRAKOZIK
SZN_KSZ
	BCF		SZNET_KRS
	RETURN

; ............... FREKI_KITARTS ................
FREKI_KITART_SUB
	BSF		FR_KITARTS_KRS
	MOVFF	FREKI_KEZD_H,FREKI_H
	MOVFF	FREKI_KEZD_L,FREKI_L		; KRT FREKI BETLTSE
	BCF		BREAK
KITARTS_VR
	BTFSS	FR_KITARTS_KRS
	BRA		KIT_VGE
	BTFSC	BREAK
	BRA		KIT_VGE
	BRA		KITARTS_VR	
KIT_VGE	
	BCF		FR_KITARTS_KRS
	RETURN


; ................... TEM ....................
TEM_DELAY
	MOVFF	VLTOZS_SEBESSGE,LPS_TEM
UU
	DECFSZ	LPS_TEM,F
	BRA		UU
	MOVFF	VLTOZS_SEBESSGE,LPS_TEM
UU2
	DECFSZ	LPS_TEM,F
	BRA		UU2
	
	RETURN	

;...............................................................................................
; -------------------- MEGSZAKITAS KEZELESE ----------------------------------------
		
MEGSZAK
	swapf 	WREG
	movwf	AKKU_TEMP 			; W REGISZTER ELTAROLASA
	swapf 	WREG	
	SWAPF	STATUS,W			; STATUS REG TAROLASA
	MOVWF	STATUS_TEMP 
	MOVFF 	BSR, BSR_TEMP 		; BSR REG TAROLASA	

	; TIMET 0?		; KB.1000HZ-EL
	BTFSS	TMR0_INT_FLAG
	BRA		TIMER1_ELL
	BCF		TMR0_INT_FLAG	

	CLRWDT
	
	BTFSC	EFFEKT_1_GOMB
	BRA		GOMB_ENG_E
	BRA		MEG_VEG				; KILPS
		
GOMB_ENG_E
	BTFSC	GOMB_ENG		; HA GOMB ENGEDLYEZS TRLVE VAN
	BRA		SZNET__ELL
	BTFSC	GOMB_LENYOMVA	; S GOMB NINCS LENYOMVA
	BRA		SZNET__ELL
	; HA MINDEN GOMB ELENGEDVE
	DECFSZ	GOMB_PRELL,F
	BRA		SZNET__ELL		
	MOVLW	.30				; msec-BEN
	MOVWF	GOMB_PRELL		; PRELLMENTEST RTK FELTLTSE
	BSF		GOMB_ENG		; GOMB KEZELS ENGEDLYZVE

	; SZNET IDZTSE	
SZNET__ELL
	BTFSS	SZNET_KRS		; SZNET KRS VAN?
	BRA		FREKI_KITART	
	DECF	SZNET_L,F
	MOVLW	0
	SUBWFB	SZNET_H,F			; HA L ALULCSORDULT, AKKOR H-1
	BNC		SZN_LEJRT			; HA EZ IS ALULCSORDULT KSZ 	
	BRA		MEG_VEG				; KILPS
SZN_LEJRT
	BCF		SZNET_KRS		; JELZS TRLVE (EGYBEN JELZI, HOGY A SZNET LEJRT
	BRA		MEG_VEG				; KILPS
	
	; FREKI KITARTS IDZTSE
FREKI_KITART
	BTFSS	FR_KITARTS_KRS	; FREKI KITARTS KRS VOLT?
	BRA		TIMER1_ELL			; HA NEM
	DECF	FREKI_KITARTS_L,F
	MOVLW	0
	SUBWFB	FREKI_KITARTS_H,F		; HA L ALULCSORDULT, AKKOR H-1
	BNC		KITARTS_LEJRT			; HA EZ IS ALULCSORDULT KSZ
	BRA		TIMER1_ELL
KITARTS_LEJRT
	BCF		FR_KITARTS_KRS	; JEL TRLVE (JELZI, HOGY LEJRT A KITARTS ID)


	; TIMER1?
TIMER1_ELL
	BTFSS	TMR1_INT_FLAG		; 
	BRA		MEG_VEG
	MOVFF	FREKI_H,TMR1H
	MOVFF	FREKI_L,TMR1L		; FREKVENCIA BELLTSA.
	
	; GOMBOK ELLENRZSE
	BTFSS	GOMB_ENG
	BRA		FREKI_STOP				; STOP

	BTFSS	EFFEKT_1_GOMB
	BRA		FREKI_STOP			; HA AZ 1. GOMB LE VAN NYOMVA, MINDEN HANG STOP
	BTFSC	RIASZTS_JEL
	BRA		SZNET_KR_ELL		; HA VAN RISZTS JEL HANGOT KELTNK
	BTFSS	EFFEKT_2_GOMB
	BRA		SZNET_KR_ELL	
	BTFSS	EFFEKT_3_GOMB
	BRA		SZNET_KR_ELL	
	BTFSS	EFFEKT_4_GOMB
	BRA		SZNET_KR_ELL
	BTFSS	EFFEKT_5_GOMB
	BRA		SZNET_KR_ELL
	BTFSS	EFFEKT_6_GOMB
	BRA		SZNET_KR_ELL

FREKI_STOP	
	BCF		SZNET_KRS	
	BCF		FR_KITARTS_KRS
	BCF		FREKI_KI_INV
	BCF		FREKI_KI_NINV	
	BSF		BREAK				; MEGSZAKTS JEL BELLTVA	
	BRA		FREKI_VGE			; KILPS

SZNET_KR_ELL
	BTFSS	SZNET_KRS		; SZNET KRS VAN?
	BRA		KRT_PERIOD_SZNET	
	BCF		FREKI_KI_INV
	BCF		FREKI_KI_NINV
	BRA		FREKI_VGE			; KILPS		

KRT_PERIOD_SZNET
	BTFSS	KRT_PERIOD_KRS
	BRA		FREKI_KI_OK
	BCF		FREKI_KI_INV
	BCF		FREKI_KI_NINV
	BRA		FREKI_VGE			; KILPS	

FREKI_KI_OK	
	; Freki kivitele lbakra
	BTFSC	FREKI_KI_INV		; LB 0?
	BRA		GO_INV
	BCF		FREKI_KI_NINV
	NOP
	NOP
	
	BSF		FREKI_KI_INV
	BRA		FREKI_VGE
GO_INV
	BTFSS	FREKI_KI_INV		; 0?
	BRA		FREKI_VGE	
	BCF		FREKI_KI_INV
	NOP
	NOP

	BSF		FREKI_KI_NINV
FREKI_VGE
	BCF		TMR1_INT_FLAG

MEG_VEG
	MOVFF 	BSR_TEMP, BSR 
	SWAPF 	STATUS_TEMP,W	 	; MENTETT REGISZTEREK VISSZAALLITASA
	MOVWF	STATUS
	swapf 	AKKU_TEMP, W 

	RETFIE	


; ************************ TBLZATOK ....................

 
 ;..................
	END
